package com.morozov.core_backend_api.message.requests

import com.morozov.core_backend_api.chat.Chat


data class MessageSendRequest(
//В случае если известен идентификатор чата - необходимо отправить данный параметр
    var chat_id: Long? = null,

//Идентификатор получателя (обязательный параметр в случае отсутствия chat_id, если chat_id задан - игнорируется).
//Для диалогов чат создается автоматически после отправки первого сообщения в него.
    var recipient_id: Long? = null,

//Только для редактирования сообщения. Если задан chat_id и message_id, то изменяется текущее указанное сообщение, а не создается новое. Изменять можно только сообщения типа standart. Анализируются и обновляются поля message и file_ids.
    var message_id: Long? = null,

//текст сообщения
//Текстовое сообщение . Максимальная длина - 4096 символов . Если длина текста больше - он будет обрезан.Клиенту необходимо самостоятельно разбивать более длинный текст на несколько сообщений .
    var message: String? = null,

//Если true - то получатель не должен получить уведомление о получении данного сообщения
    var silent: Boolean = false,

    //Идентификатор сообщения, репостом которого является отправляемое сообщение
    var repost_message_id: Long? = null,

    //Идентификатор сообщения, ответом на которое является отправляемое сообщение
    var reply_to: Long? = null,

//Показывать или нет превью ссылки в случае валидного url в тексте сообщений
    var show_link: Boolean? = null,

//Массив с идентификаторами загруженных ранее файлов. Может быть пустой или отсутствовать. Медиафайлы добавляются именно в том порядке к сообщению, в котором пришли в массиве file_ids
    var file_ids: MutableList<String> = mutableListOf(),

//Идентификатор отправляемого стикера. ПРи отправке стикера и указания соответствующего типа сообщения остальные поля проигнорированы. Если тип сообщения не стикер - то это поле будет проигнорировано.
    var sticker_id: Long? = null,

//Тип сообщения
    @Chat.Companion.Type
    var type: Int? = null,

//Идентификатор отправляемого контакта. В случае отправки сообщения с типом “контакт” будет обработано дополнительно только поле message. Остальные поля проигнорированы.
    var contact_id: Long? = null,

//[latitude, longitude]
//Координаты места. Обрабатывается если тип сообщения location. Дополнительно будет обработано только поле message.
    var location: MutableList<Double>? = mutableListOf(),

//Массив с хештегами к сообщениям
    var hashtags: MutableList<String> = mutableListOf(),

//['like’, ‘dislike’, ‘confirm’]
//Массив с реакциями, которые надо добавить. ВАЖНО - редактировать реакции нельзя. ПРи их изменении - удаляются все старые реакции и добавляются новые. Счетчики сбрасываются.
    var reactions: MutableList<String> = mutableListOf()
)